=== modified file 'environs/jujutest/livetests.go'
--- environs/jujutest/livetests.go	2012-09-03 14:07:19 +0000
+++ environs/jujutest/livetests.go	2012-09-03 16:29:38 +0000
@@ -157,8 +157,7 @@
 	}
 	t.BootstrapOnce(c)
 
-	// TODO(dfc) constructing a juju.Conn by hand is a code smell.
-	conn, err := juju.NewConnFromAttrs(t.Env.Config().AllAttrs())
+	conn, err := juju.NewConnFromEnviron(t.Env)
 	c.Assert(err, IsNil)
 	defer conn.Close()
 

=== modified file 'juju/conn.go'
--- juju/conn.go	2012-09-03 14:18:45 +0000
+++ juju/conn.go	2012-09-03 16:29:38 +0000
@@ -56,16 +56,6 @@
 	return NewConnFromEnviron(environ)
 }
 
-// NewConnFromAttrs returns a Conn pointing at the environment
-// created with the given attributes, as created with environs.NewFromAttrs.
-func NewConnFromAttrs(attrs map[string]interface{}) (*Conn, error) {
-	environ, err := environs.NewFromAttrs(attrs)
-	if err != nil {
-		return nil, err
-	}
-	return NewConnFromEnviron(environ)
-}
-
 // Close terminates the connection to the environment and releases
 // any associated resources.
 func (c *Conn) Close() error {

=== modified file 'juju/conn_test.go'
--- juju/conn_test.go	2012-09-03 14:09:44 +0000
+++ juju/conn_test.go	2012-09-03 16:29:38 +0000
@@ -80,28 +80,6 @@
 	conn.Close()
 }
 
-func (*ConnSuite) TestNewConnFromAttrs(c *C) {
-	attrs := map[string]interface{}{
-		"name":            "erewhemos",
-		"type":            "dummy",
-		"zookeeper":       true,
-		"authorized-keys": "i-am-a-key",
-	}
-	conn, err := juju.NewConnFromAttrs(attrs)
-	c.Assert(err, ErrorMatches, "dummy environment not bootstrapped")
-
-	environ, err := environs.NewFromAttrs(attrs)
-	c.Assert(err, IsNil)
-	err = environ.Bootstrap(false)
-	c.Assert(err, IsNil)
-
-	conn, err = juju.NewConnFromAttrs(attrs)
-	c.Assert(err, IsNil)
-	defer conn.Close()
-	c.Assert(conn.Environ.Name(), Equals, "erewhemos")
-	c.Assert(conn.State, NotNil)
-}
-
 func (cs *ConnSuite) TestConnStateSecretsSideEffect(c *C) {
 	attrs := map[string]interface{}{
 		"name":            "erewhemos",
@@ -119,12 +97,12 @@
 	st, err := state.Open(info)
 	c.Assert(err, IsNil)
 
-	// verify we have no secret in the environ config
+	// Verify we have no secret in the environ config
 	cfg, err := st.EnvironConfig()
 	c.Assert(err, IsNil)
 	c.Assert(cfg.UnknownAttrs()["secret"], IsNil)
 
-	conn, err := juju.NewConnFromAttrs(attrs)
+	conn, err := juju.NewConnFromEnviron(env)
 	c.Assert(err, IsNil)
 	defer conn.Close()
 	// fetch a state connection via the conn, which will 

